<template>
  <el-card shadow="never" class="aui-card--fill">
    <div class="mod-sys__user">
      <search-bar :formConfigs="formConfig" ref="searchBarForm" @headBtnClick="buttonClick" />
      <base-table :table-props="tableProps" :page="listQuery.page" :limit="listQuery.limit" :table-data="tableData">
        <method-btn v-if="tableBtn.length" slot="handleBtn" :width="100" label="操作" :method-list="tableBtn"
          @clickBtn="handleClick" />
      </base-table>
      <pagination :limit.sync="listQuery.limit" :page.sync="listQuery.page" :total="listQuery.total"
        @pagination="getDataList" />
      <!-- 弹窗, 新增 / 修改 -->
      <base-dialog :dialogTitle="addOrEditTitle" :dialogVisible="addOrUpdateVisible" @cancel="handleCancel"
        @confirm="handleConfirm" :before-close="handleCancel">
        <add-or-update ref="addOrUpdate" @refreshDataList="successSubmit"></add-or-update>
      </base-dialog>
    </div>
  </el-card>
</template>

<script>
import basicPage from "@/mixins/basic-page";
import AddOrUpdate from "./dict-data-add-or-update";
import i18n from "@/i18n";
const tableProps = [
  {
    prop: "dictValue",
    label: i18n.t("dict.dictValue"),
  },
  {
    prop: "dictLabel",
    label: i18n.t("dict.dictLabel"),
  },
  {
    prop: "sort",
    label: i18n.t("dict.sort"),
  },
  {
    prop: "remark",
    label: i18n.t("dict.remark"),
  },
  {
    prop: "createDate",
    label: i18n.t("dict.createDate"),
  },
];
const tableBtn = [
  {
    type: "edit",
    btnName: "编辑",
  },
  {
    type: "delete",
    btnName: "删除",
  },
];
export default {
  mixins: [basicPage],
  data() {
    return {
      urlOptions: {
        getDataListURL: "/sys/dict/data/page",
        deleteURL: "/sys/dict/data",
      },
      tableProps,
      tableBtn,
      formConfig: [
        {
          type: "input",
          label: i18n.t("dict.dictValue"),
          placeholder: i18n.t("dict.dictValue"),
          param: "dictValue",
        },
        {
          type: "input",
          label: i18n.t("dict.dictLabel"),
          placeholder: i18n.t("dict.dictLabel"),
          param: "dictLabel",
        },
        {
          type: "button",
          btnName: "查询",
          name: "search",
          color: "primary",
        },
        {
          type: "button",
          btnName: "新增",
          name: "add",
          color: "primary",
          plain: true,
        },
      ],
    };
  },
  components: {
    AddOrUpdate,
  },
  created() {
    this.listQuery.dictTypeId = this.$route.params.dictTypeId || "0";
    this.getDataList();
  },
  methods: {
    //search-bar点击
    buttonClick(val) {
      switch (val.btnName) {
        case "search":
          this.listQuery.dictValue = val.dictValue;
          this.listQuery.dictLabel = val.dictLabel;
          this.listQuery.page = 1;
          this.getDataList();
          break;
        case "add":
          this.addOrEditTitle = "新增";
          this.addOrUpdateVisible = true;
          this.addOrUpdateHandle();
          break;
        default:
          console.log(val);
      }
    },
    // 新增 / 修改
    addOrUpdateHandle(id) {
      this.addOrUpdateVisible = true;
      this.$nextTick(() => {
        this.$refs.addOrUpdate.init(id, this.listQuery.dictTypeId);
      });
    },
  },
};
</script>
